#!/usr/bin/perl
use strict;
use DBI;
use Getopt::Std;
use Net::SMTP;

BEGIN {
$ENV{NLS_LANG} = 'american';
$ENV{ORACLE_HOME} = '/radius/t00/oracle/product/10.2.0';
$ENV{ORACLE_SID} = 'RADDEV';
$ENV{LD_LIBRARY_PATH} = '/usr/lib:/etc/lib:/usr/local/lib:/usr/lib/mysql';
}

my $mailhost    =       'your-mail-server;
my $maildomain  =       'domain';
my $mailfrom    =       'abc@abc.com;
my $mailto              ='xyz@xyz.com';
my $timeout             =       30;
my $mailsubject =       '';                                                     #       Leave blank
my $mailbody    =       '';

#################################################################
#
# Commandline options
#
# -n    NOTIFICATIONTYPE
# -h    HOSTNAME
# -s    HOSTSTATE
# -d    LONGDATETIME
# -e    CONTACTEMAIL

our ($opt_n, $opt_h, $opt_s , $opt_a , $opt_i , $opt_d , $opt_e);

getopt('nhsaide');

if (not defined $opt_n or $opt_n eq "") {
        print "option -n not defined!\n";
        $opt_n = "UNDEFINED";
}
elsif (not defined $opt_h or $opt_h eq "") {
        print "option -h not defined!\n";
        $opt_h = "UNDEFINED";
}
elsif (not defined $opt_s or $opt_s eq "") {
        print "option -s not defined!\n";
        $opt_s = "UNDEFINED";
}
elsif (not defined $opt_d or $opt_d eq "") {
        print "option -d not defined!\n";
        $opt_d = "UNDEFINED";
}
elsif (not defined $opt_e or $opt_e eq "") {
        die "CRITICAL: option -e not defined!.  Host $opt_h, Notification: $opt_n, State: $opt_s, Info: $opt_i\n";
}

############Connect to Database and fecth data on the base of Device name################

my $dbh = DBI->connect( 'dbi:Oracle:RADDEV',
                        'radiator',
                        'radiator',
                        {
                          RaiseError => 1,
                          AutoCommit => 0
                        }
                      ) || die "Database connection not made: $DBI::errstr";

my $sql = qq{ SELECT name,mobile,site FROM PNS where device = '$opt_n'  };
my $sth = $dbh->prepare( $sql );
$sth->execute();

my( $name, $mobile,$site);
$sth->bind_columns( undef,\$name, \$mobile, \$site);

while( $sth->fetch() ) {
  $name = $name;
  $mobile = $mobile;
  $site = $site;
}

$sth->finish();
$dbh->disconnect();

$mailsubject    =       "Nagios Monitoring Alert: $opt_h is $opt_s";
$mailto                 =       "$opt_e";

$mailbody = <<_END_;
***** Nagios  *****

Device Name: $opt_n
Host: $opt_h
State: $opt_s
Date/Time: $opt_d
Contact Name: $name
Mobile Number: $mobile
Site Name: $site
_END_

sendmail();

sub sendmail {
        my $smtp = Net::SMTP->new(
                                                                $mailhost,
                                                                Hello => $maildomain,
                                                                Timeout => $timeout,
                                                                Debug   => $debug,
                                                                );

        $smtp->mail($mailfrom);
        $smtp->to($mailto);

        $smtp->data();
        $smtp->datasend("To: $mailto\n");
        $smtp->datasend("From: $mailfrom\n");
        $smtp->datasend("Subject: $mailsubject\n");
        $smtp->datasend("\n");
        $smtp->datasend("$mailbody\n");
        $smtp->dataend();

        $smtp->quit;
}